// Indenter add-on for BeIDE's editor (works on TAB characters)
//
// Written by Olivier Wittenberg, February 1997
// (witt@lenet.fr up to about July I think)

#include <string.h>
#include "MTextAddOn.h"

#pragma export on
extern "C" {
	long perform_edit (MTextAddOn *);
}
#pragma export reset

//
// perform_edit: the public function
//

long perform_edit (MTextAddOn *addon)
{
	bool shift = !!(modifiers () & B_SHIFT_KEY);
	// First we get what we need from the editor
	long selStart, selEnd;

	addon->GetSelection (&selStart, &selEnd);
	if (selEnd <= selStart)
		return (B_ERROR);
	
	const char *text = addon->Text ();
	const char *s;

	if (!shift) { // We add a TAB character to each line
		// We need to count the number of lines
		int n = 1;

		for (s = text + selStart; s < text + selEnd - 1; s++)
			if (*s == '\n')
				n++;

		// Now, the work we've been hired for...
		// We won't process the last character because it's often undesired.
		char *newtext = new char [selEnd - selStart + n + 2], *o = newtext;

		*o++ = '\t';
		for (s = text + selStart; s < text + selEnd - 1; s++) {
			*o++ = *s;
			if (*s == '\n')
				if (s[1] == '\n') // No need to indent the line if it's empty
					n--;
				else
					*o++ = '\t';
		}
		o[0] = *s;
		o[1] = 0;

		addon->Delete ();
		addon->Insert (newtext);
		addon->Select (selStart, selEnd + n);

		delete [] newtext;
	}
	else { // We remove the TAB character of each line
		char *newtext = new char [selEnd - selStart + 1], *o = newtext;
		bool ok = TRUE;

		s = text + selStart;
		if (*s == '\t')
			s++;

		for (; s < text + selEnd - 1 && ok; s++) {
			*o++ = *s;
			if (*s == '\n')
				if (s[1] == '\t')
					s++;
				else
				if (s[1] != '\n')
					ok = FALSE;
		}
		o[0] = *s;
		o[1] = 0;

		if (ok) { // Every line was beginning with a TAB character
			addon->Delete ();
			addon->Insert (newtext);
			addon->Select (selStart, selStart + strlen (newtext));
		}
	}	

	return (B_NO_ERROR);
}